


#include <avr/pgmspace.h>
#include <EEPROM.h>
#include "mpguino_conf.h"

#if( SLEEP_CFG == 3 )
#include <avr/sleep.h>
#endif
#include <SPI.h>
//#include <SD.h>


#include <TFT_ILI9341.h>
#define RED2RED 0
#define GREEN2GREEN 1
#define BLUE2BLUE 2
#define BLUE2RED 3
#define GREEN2RED 4
#define RED2GREEN 5
#include <URTouch.h>

TFT_ILI9341 tft = TFT_ILI9341();       

#define HX8357_GREY 0x2104 

uint32_t runTime = -99999;

long templong=0;

unsigned long MAXLOOPLENGTH;                 
long LOOPTIME=0;
//for display computing
static unsigned long tmp1[2];
static unsigned long tmp10[2];
static unsigned long tmp2[2];
static unsigned long tmp20[2];
static unsigned long tmp3[2];





//middle button cycles through these brightness settings      

volatile unsigned long timer2_overflow_count;





#include "mpguino.h";
//#include "lcd.h"

















/* --- End Global Variable Declarations ---------------------- */


/*** Set up the Events ***
 * We have our own ISR for timer2 which gets called about once a millisecond.
 * So we define certain event functions that we can schedule by calling addEvent
 * with the event ID and the number of milliseconds to wait before calling the event. 
 * The milliseconds is approximate.
 * 
 * Keep the event functions SMALL!!!  This is an interrupt!
 * 
 */
//event functions



int tempscreen=1;
//int touchorient;
int cp;
int cps;
URTouch  myTouch(11, 10, 9, 8, 7);
int screenstate=EEPROM.read(911); ////////////////// old init value for screen dimness 250;
int touchorient=EEPROM.read(912); ////////////////// old init value for screen dimness 250;

int menuitem;
long tempfill;
long fueladd=0;
long mpg;
long mpgmax;
long zero=0;
int refresher;
int reading = 0; // Value to be displayed
long xss;
long yss;
int page;
int tankmpg;
int d = 0; // Variable used for the sinewave test waveform
int rd=0;
boolean alert = 0;
int8_t ramp = 1;



int bluetoothtrigger=0;

unsigned long oldset;





//void enableLButton(){PCMSK2  |= (1 << PCINT19);}
//void enableMButton(){PCMSK2  |= (1 << PCINT20);}
//void enableRButton(){PCMSK2  |= (1 << PCINT21);}
//array of the event functions}

pFunc eventFuncs[] ={
  enableVSS};
#define eventFuncSize (sizeof(eventFuncs)/sizeof(pFunc)) 
//define the event IDs
#define enableVSSID 0
//#define enableLButtonID 1
//#define enableMButtonID 2
//#define enableRButtonID 3
//ms counters
unsigned int eventFuncCounts[eventFuncSize];

//schedule an event to occur ms milliseconds from now
void addEvent(unsigned char eventID, unsigned int ms){
  if(ms == 0) {
    eventFuncs[eventID]();
  }
  else {
    eventFuncCounts[eventID]=ms;
  }
}

/* this ISR gets called every 1.024 milliseconds, we will call that a 
 * millisecond for our purposes go through all the event counts, if any 
 * are non zero subtract 1 and call the associated function if it just 
 * turned zero.  */
ISR(TIMER2_OVF_vect) {
  unsigned char eventID;
  timer2_overflow_count++;
  for(eventID = 0; eventID < eventFuncSize; eventID++) {
    if(eventFuncCounts[eventID]!= 0) {
      eventFuncCounts[eventID]--;
      if(eventFuncCounts[eventID] == 0) {
        eventFuncs[eventID](); 
      }
    }  
  }
} /* ISR(TIMER2_OVF_vect) */

//unsigned char buttonState = buttonsUp;      

//overflow counter used by millis2()      
unsigned long lastMicroSeconds=millis2() * 1000;   
unsigned long microSeconds(void) {     
  unsigned long tmp_timer2_overflow_count;    
  unsigned long tmp;    
  unsigned char tmp_tcnt2;    
  cli(); //disable interrupts    
  tmp_timer2_overflow_count = timer2_overflow_count;    
  tmp_tcnt2 = TCNT2;    
  sei(); // enable interrupts    
  tmp = ((tmp_timer2_overflow_count << 8) + tmp_tcnt2) * 4;     
  if((tmp<=lastMicroSeconds) && (lastMicroSeconds<4290560000ul)) {
    return microSeconds();     
  }
  lastMicroSeconds=tmp;   
  return tmp;     
}    

unsigned long elapsedMicroseconds(unsigned long startMicroSeconds, unsigned long currentMicroseconds) {      
  if(currentMicroseconds >= startMicroSeconds) {
    return currentMicroseconds-startMicroSeconds;      
  }
  return 0xFFFFFFFF - (startMicroSeconds-currentMicroseconds);      
}      

unsigned long elapsedMicroseconds(unsigned long startMicroSeconds ){      
  return elapsedMicroseconds(startMicroSeconds, microSeconds());
}      


//main objects we will be working with:      
unsigned long injHiStart; //for timing injector pulses      
Trip tmpTrip;      
Trip instant;      
Trip current;      
Trip tank;



unsigned volatile long instInjStart=nil; 
unsigned volatile long tmpInstInjStart=nil; 
unsigned volatile long instInjEnd; 
unsigned volatile long tmpInstInjEnd; 
unsigned volatile long instInjTot; 
unsigned volatile long tmpInstInjTot;     
unsigned volatile long instInjCount; 
unsigned volatile long tmpInstInjCount;     

boolean lookForOpenPulse = true;

void processInjOpen(void){      
  //20110831 AJT Peak and Hold ;)
  if(lookForOpenPulse || parms[injEdgeIdx] != 2){
    injHiStart = microSeconds();
  }
}      

void processInjClosed(void){
  //20110831 AJT Peak and Hold ;)
  long t =  microSeconds();
  long x = elapsedMicroseconds(injHiStart, t) - parms[injectorSettleTimeIdx];   

  if( parms[injEdgeIdx]==3 ){
    if (x >0) {
      tmpTrip.injHius += x;
    }
    tmpTrip.injPulses++;      
    if (tmpInstInjStart != nil) {
      if (x >0) {
        tmpInstInjTot += x;
      }
      tmpInstInjCount++;
    } 
    else {
      tmpInstInjStart = t;
    }
    tmpInstInjEnd = t;
  }
  else {
    if(parms[injEdgeIdx]==2 && x < 0){
      lookForOpenPulse=false;
    } 
    else {
      if(parms[injEdgeIdx]==2 || x > 0){
        tmpTrip.injHius += x;
      }

      tmpTrip.injPulses++;  
      if (tmpInstInjStart != nil) {
        if(parms[injEdgeIdx]==2 || x > 0){
          tmpInstInjTot += x;     
        }
        tmpInstInjCount++;
      } 
      else {
        tmpInstInjStart = t;
      }  
      tmpInstInjEnd = t;
      lookForOpenPulse=true;
    }
  }
}

volatile boolean vssFlop = 0;

void enableVSS(){
  vssFlop = !vssFlop;
}

unsigned volatile long lastVSS1;
unsigned volatile long lastVSSTime;
unsigned volatile long lastVSS2;

volatile boolean lastVssFlop = vssFlop;

//attach the vss/buttons interrupt      
ISR(PCINT2_vect) {   
  static unsigned char vsspinstate=0;      
  unsigned char p = PINK;//bypassing digitalRead for interrupt performance      

  if ((p & vssBit) != (vsspinstate & vssBit)){      
    addEvent(enableVSSID,parms[vsspause] ); //check back in a couple milli
  }
  if(lastVssFlop != vssFlop){


    lastVSS1=lastVSS2;
    unsigned long t = microSeconds();
    lastVSS2=elapsedMicroseconds(lastVSSTime,t);
    lastVSSTime=t;
    tmpTrip.vssPulses++; 
    tmpTrip.vssPulseLength += lastVSS2;
    lastVssFlop = vssFlop;
  }
  vsspinstate = p;      
  // buttonState &= p;      
} /* ISR(PCINT1_vect) */


pFunc displayFuncs[] ={ 

  doDisplayMenu,
  doDisplay1, 
  doDisplaySpeed, 
  doDisplayDTEODO, 
  doDisplayLarge1, 
  doDisplayLarge2, 
  doDisplayCust1, 
  doDisplayCustLarge1, 
  doBlue


    // doDisplayCarSensors,
};      

#define displayFuncSize (sizeof(displayFuncs)/sizeof(pFunc)) //array size      

///////////////////////bluetooth//////////////////////////////////////////////
int       senddd=1;
int brek=0;
char readflag;
String cz;
String az;
long setting1=1;
long loopnz; 
long nummz;

//const OLED_Color GGREEN = { 11, 60, 3 };


unsigned char newRun = 0;

//const int pin=26;
const int pwmpin=12;

void setup (void) {
  //. delay(1000);
  myTouch.InitTouch(1);
  myTouch.setPrecision(PREC_LOW);
  //pinMode(pin, OUTPUT);
  //digitalWrite(pin,LOW);
  analogWrite(pwmpin,screenstate);
  pinMode(19, INPUT);   // digital sensor is on digital pin 2
  pinMode(18, OUTPUT);   // digital sensor is on digital pin 2

  tft.begin();
  tft.setRotation(1);
  tft.fillScreen(TFT_BLACK);
  tft.setTextWrap(false);

  // tft.drawString("MPGuino TFT Touch",             5,20, 4);
  //tft.drawString("version 8.1 ",             5,50, 4);
  //.  tft.drawString("Continue...",             155,190, 4);
  //.  tft.drawString("Press and Hold here to",             155,180, 1);
  //tft.drawString("abbalooga 07 MAR 2019",       185,225, 1);
  Serial.begin(9600);
  Serial1.begin(9600);
  //  delay(500);
  //  Serial1.print("AT+NAMEMPGuino0002");
  //    delay(200);
  // Serial1.print("AT+NOTI0");

  cp=0;

  SCREEN = EEPROM.read(910);

  if (SCREEN==0) SCREEN=1;



  extrainfo=0;
  CLOCK = 0;
  HOLD_DISPLAY = 0;

#if (CFG_IDLE_MESSAGE != 0)
  IDLE_DISPLAY_DELAY = 0;
#endif

  //edit september///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  //remove init at start
  init2();
  //debug
  // newRun = load();
  load();







  pinMode(InjectorOpenPin, INPUT);       
  pinMode(InjectorClosedPin, INPUT);       
  pinMode(VSSPin, INPUT);            
  attachInterrupt(0, processInjOpen, parms[injEdgeIdx]==1? RISING:FALLING);      
  attachInterrupt(1, processInjClosed, parms[injEdgeIdx]==1? FALLING:RISING); 

  //  pinMode( lbuttonPin, INPUT );       
  //  pinMode( mbuttonPin, INPUT );       
  //  pinMode( rbuttonPin, INPUT );      

  //"turn on" the internal pullup resistors      
  //   digitalWrite( lbuttonPin, HIGH);       
  //  digitalWrite( mbuttonPin, HIGH);       
  //  digitalWrite( rbuttonPin, HIGH);       
  digitalWrite( VSSPin, HIGH);       

  //low level interrupt enable stuff    
  //////////////////////////////////////////////////////////////////////////////////////////////////////////  
  // PCMSK1 |= (1 << PCINT8);


  //  enableLButton();
  //   enableMButton();
  //   enableRButton();
  // PCICR |= (1 << PCIE1);       






  PCMSK2 |= (1 << PCINT16); // enable VSS pin interrupt


  PCICR |= (1 << PCIE2); // enable selected interrupts on port K



  ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  //PRR0 |= ((1 << PRTWI) | (1 << PRSPI) | (1 << PRADC) | (1 << PRUSART0)); // disable TWI, SPI, ADC, USART0 modules to reduce power consumption
  //	PRR1 |= ((1 << PRTIM5) | (1 << PRTIM4) | (1 << PRTIM3) | (1 << PRUSART3) | (1 << PRUSART2) | (1 << PRUSART1)); // disable timer5, timer4, timer3, USART3, USART2, USART1 modules to reduce power consumption






  //  initGuino();


  //  delay(100);

};

/* void setup (void) */





void loop (void) {
  // delay(1500);
  tft.fillScreen(TFT_BLACK);

  int screencount=7;
  long xss, yss;
  touchorient=EEPROM.read(912);
  if(touchorient!=1){
    if(touchorient!=0){
      touchorient=0;
    }
  };
  // version 20  touchorient=parms[currentTripResetTimeoutUSIdx];
  if (SCREEN>=screencount+1) SCREEN=1;

  //saveTankData();
  unsigned long fluff=1;
  unsigned long fluff2=1;
  unsigned long time=0;
  unsigned long lastActivity;
  unsigned long tankHold;      //state at point of last activity
  unsigned long loopStart;
  unsigned long temp;          //scratch variable
  unsigned poopp;
  lastActivity = microSeconds();

  loadTankData();
  while (true) {     

    loopStart = microSeconds();   

    unsigned poop=(microSeconds()-poopp);

    long CFG_UNITS =                parms[currentTripResetTimeoutUSIdx];  /* 1=US  2=METRIC  */

#if (CFG_FUELCUT_INDICATOR != 0)
    FCUT_POS = 0;
#endif

#if (OUTSIDE_TEMP_CFG == 1)
    CALC_FILTERED_TEMP();
#endif
    ///touchorient=0;
    // version 20  touchorient=parms[currentTripResetTimeoutUSIdx];

    instant.reset();           //clear instant      
    cli();
    instant.update(tmpTrip);   //"copy" of tmpTrip in instant now      
    tmpTrip.reset();           //reset tmpTrip first so we don't lose too many interrupts      
    instInjStart=tmpInstInjStart; 
    instInjEnd=tmpInstInjEnd; 
    instInjTot=tmpInstInjTot;     
    instInjCount=tmpInstInjCount;

    tmpInstInjStart=nil; 
    tmpInstInjEnd=nil; 
    tmpInstInjTot=0;     
    tmpInstInjCount=0;

    sei();

    if(parms[contrastIdx]==6) fueladd=0;





    /* --- update all of the trip objects */
    current.update(instant);       //use instant to update current      
    tank.update(instant);          //use instant to update tank



    //  tft.drawNumber(fluff, 280,15, 1);
    // tft.drawNumber(fluff2, 280,23, 1);

    if (time>=1) time=time+1;
    if (time>=7) {
      tft.fillRect(   120,0,40,13,TFT_BLACK);
      time=0;
    }

    if ((fluff == 0)&&(instant.vssPulses==0)) {  //save tank data when stopped incase of car off before screen timeout
      saveTankData();
      fluff = 1;
      time=1;
      tft.setTextDatum(TL_DATUM);

      tft.drawString("SAVED", 120,1, 1); //280,15
    }  

    if ((instantrpm()>=1)&&(instant.vssPulses==0)){
      fluff=fluff+1;
      if (fluff>=40) { 
        saveTankData();
        fluff = 1;
        time=1;
        tft.setTextDatum(TL_DATUM);

        tft.drawString("SAVED", 120,1, 1);
      }
    }

    if (instantrpm()>=1){
      fluff2=fluff2+1;
      if (fluff2>=600) { 
        saveTankData();
        fluff2 = 1;
        time=1;
        tft.setTextDatum(TL_DATUM);

        tft.drawString("SAVED", 120,1, 1);
      }
    }

    if (instant.vssPulses>=1) fluff=0  ; //allow tank to be saved next time stopped

    // }



    //  if (bluetoothtrigger==1) SCREEN=8;


    if (HOLD_DISPLAY == 0) {

#if (CFG_IDLE_MESSAGE == 0)
      displayFuncs[SCREEN]();    //call the appropriate display routine      
#elif (CFG_IDLE_MESSAGE == 1)
      /* --- during idle, jump to EOC information */
      if (    (instant.injPulses >  0) 
        && (instant.vssPulses == 0) 
        ) 
      {
        /* the intention of the below logic is to avoid the display flipping 
         in stop and go traffic.  When you come to a stop, the delay timer 
         starts incrementing.  When you drive off, it decrements.  When the
         timer is zero, the display is always at the user-specified screen */
        if (IDLE_DISPLAY_DELAY < 6) {
          /* count up until delay time is reached */
          IDLE_DISPLAY_DELAY++;
        }
      }
      else {
        if (IdleDisplayRequested) {
          /* count from delay time back down to zero */
          IDLE_DISPLAY_DELAY--;
        }
        else if (IDLE_DISPLAY_DELAY < 0) {
          /* if the user selected a new screen while stopped, reset 
           the delay timer after driveoff */
          IDLE_DISPLAY_DELAY = 0;
        }
      }

      if (IdleDisplayRequested) {
        doDisplayEOCIdleData();
      }
      else {
        displayFuncs[SCREEN]();
      }
#endif



      if (SCREEN==0)   {
        SCREEN_2();
      }
      else
      {
        tft.setCursor(0, 0);

        myTouch.read();
        xss = myTouch.getX();
        yss = myTouch.getY();
        if (touchorient==1){ 
          xss=320-xss;
          yss=240-yss;
        }

        if (xss>=0 && xss<=40){
          if (yss>=130){
            cp=cp+1;
            if (cp>=3) {
              if (SCREEN<=(screencount-1)) {
                tft.fillScreen(TFT_BLACK);
                SCREEN++;       
              }
              else {
                tft.fillScreen(TFT_BLACK);
                SCREEN=1;      
              }
              cp=0;
              EEPROM.write(910,SCREEN);
            }
          }
          else if (yss>=1 && yss<=60){
            cp=cp+1;
            if (cp>=6) { 
              tft.fillScreen(TFT_BLACK);  
              cp=0; 
              fluff=0;
              time=1;
              tempscreen=SCREEN;
              SCREEN=0;  
              ;
            }
          }
        }

        if (xss>=50 && xss<=100){
          if (yss>=130){
            cp=cp+1;
            if (cp>=3) {
              if (SCREEN>=2) {
                tft.fillScreen(TFT_BLACK);
                SCREEN--;       
              }
              else {
                tft.fillScreen(TFT_BLACK);
                SCREEN=(screencount);      
              }
              cp=0;
              EEPROM.write(910,SCREEN);
            }
          }


        }

        if (xss>=230 && xss<=318){
          if(yss>=0 && yss<=100){
            cp=cp+1;
            if(cp>=3){
              screenstate=screenstate-40;
              if(screenstate<=25)screenstate=25; 
              EEPROM.write(911,screenstate);
              analogWrite(pwmpin,screenstate);
              if(cp>=35){
                if(cp<=40){
                  if(touchorient==1){
                    touchorient=0;
                    cp=41;
                    EEPROM.write(912,0);
                  };
                };
              };
              if(cp>=35){
                if(cp<=40){
                  if(touchorient==0){
                    touchorient=1;
                    cp=41;
                    EEPROM.write(912,1);
                  };
                };
              };
            };
          };
          if(yss>= 150){
            cp=cp+1;
            if(cp>=3){
              screenstate=screenstate+40;
              if(screenstate>=254)screenstate=253;
              EEPROM.write(911,screenstate);
              analogWrite(pwmpin,screenstate);
            };
          };
        }
        if (xss==-1) cp=0; 
        if (xss==321) cp=0; 
        if (yss==-1) cp=0; 
        if (yss==241) cp=0; 
        //if(screenstate>=254)screenstate=253;
        //if(screenstate<=5)screenstate=5;
        //if (lastActivity = nil){} else 
        //analogWrite(pwmpin,screenstate);
        //DEBUG TOUCH
        tft.setTextPadding(30);

        if (cp>=1) {
          lastActivity=loopStart;
          tft.setTextPadding(10);
          tft.setTextDatum(TL_DATUM);

          tft.drawNumber(cp,3,245,1);
        }
        else 
          tft.drawString("    ",1,245,1);


        if (cp>=2) analogWrite(pwmpin,screenstate);
        if (cp>=100)   {      
          tft.drawString("do you have nothing better to do...",15,235,1); 

        }
        if (cp>=100)   {      
          tft.drawString("do you have nothing better to do...",15,235,1); 

        }
        tft.setTextPadding(00);

        if(parms[contrastIdx]==69){
          tft.drawString(format(xss*1000),150,234,1);
          tft.drawString(format(yss*1000),200,234,1);
          tft.drawString(format(elapsedMicroseconds(loopStart)),100,234,1);
        }
      }

    }  /* if (HOLD_DISPLAY == 0) */
    else {
      HOLD_DISPLAY = 0;
    } 

    MAXLOOPLENGTH = MAX(MAXLOOPLENGTH, elapsedMicroseconds(loopStart));

    bluetooth();
    LOOPTIME=elapsedMicroseconds(loopStart);
    while (elapsedMicroseconds(loopStart) < (looptime)) {
      // wait for the end of the loop to arrive (0.5 sec)

      continue;
    }

    CLOCK++;

  } /* while (true) */
} /* loop (void) */

//--------------------------------------------------------
char *format(unsigned long num) {
  static char fBuff[7];  //used by format
  unsigned char dp = 3;
  unsigned char x = 6;

  while (num > 999999) {
    num /= 10;
    dp++;
    if( dp == 5 ) break; /* We'll lose the top numbers like an odometer */
  }
  if (dp == 5) {
    dp = 99;
  }                       /* We don't need a decimal point here. */

  /* Round off the non-printed value. */
  if((num % 10) > 4) {
    num += 10;
  }

  num /= 10;


  while (x > 0) {
    x--;
    if (x == dp) {
      /* time to poke in the decimal point? */
      fBuff[x]='.';
    }
    else {
      /* poke the ascii character for the digit. */
      fBuff[x]= '0' + (num % 10);
      num /= 10;
    }
  }

  if( fBuff[0]=='0' ) { //if leftmost char is 0 then replace it with space: '099.56' => ' 99.56'
    fBuff[0]=' ';
    if( fBuff[1]=='0' ) fBuff[1]=' ';
  }

  fBuff[6] = 0;
  return fBuff;
}

//--------------------------------------------------------
char* intformat(unsigned long num, byte numlength=6)
{
  static char fBuff[7];  //used by format

  //if number doesn't fit, show 9999 (92 bytes)
  if(numlength==6 && num > 999999999){
    num = 999999000ul;
  }
  else if(numlength==5 && num > 99999999){
    num = 99999000ul;
  }
  else if(numlength==4 && num > 9999999){
    num = 9999000ul;
  }


  num /= 100;
  // Round off the non-printed value.
  if((num % 10) > 4) num += 10;
  num /= 10;

  byte x = numlength;
  fBuff[x] = 0;//end string with \0
  while(x > 0){
    x--;
    fBuff[x]= '0' + (num % 10);//poke the ascii character for the digit.
    num /= 10; 
  }

  //replace leading 0 with ' '
  boolean leadnulls = true;
  while(x < numlength-1 && leadnulls){
    fBuff[x]=='0' ? fBuff[x]=' ' : leadnulls = false;
    x++;
  }

  return fBuff;  
}

//get a string from flash 
char *getStr(prog_char * str) { 
  static char mBuff[17]; //used by getStr 
  strcpy_P(mBuff, str); 
  return mBuff; 
} 

















int ringMeterColour(int value, int vmin, int vmax, int x, int y, int r, char *units, byte scheme, long tomato)
{
  // Calculate coords of centre of ring
  int w = r / 3;    // Width of outer ring is 1/4 of radius
  int v = map(value, vmin, vmax, 0, 216); // Map the value to an angle v
  byte inc = 6; // Draw segments every 3 degrees, increase to 6 for segmented ring
  // Variable to save "value" text colour from scheme and set default
  int colour = TFT_BLUE;
  int dtex = map((current.mpg()/10),vmin,vmax,0,36);

  for (int ii = 0; ii <= 216; ii=ii+ 6) {
    // Calculate pair of coordinates for segment start
    if (ii==(dtex*6)){
      tft.fillRect(20,227-(dtex*6),80,3,TFT_RED);// Variable to save "value" text colour from scheme and set default
    }
    else
      if (ii < v) { // Fill in coloured segments with 2 triangles
        switch (scheme) {
        case 0: 
          colour = TFT_RED; 
          break; // Fixed colour
        case 1: 
          colour = TFT_GREEN; 
          break; // Fixed colour
        case 2: 
          colour = TFT_BLUE; 
          break; // Fixed colour
        case 3: 
          colour = rainbow(map(ii, 0, 216, 0, 127)); 
          break; // Full spectrum blue to red
        case 4: 
          colour = rainbow(map(ii, 0, 216, 70, 127)); 
          break; // Green to red (high temperature etc)
        case 5: 
          colour = rainbow(map(ii, 0, 216, 127, 63)); 
          break; // Red to green (low battery etc)
        default: 
          colour = TFT_BLUE; 
          break; // Fixed colour
        }
        tft.fillRect(20, 227-ii, 80, 3, colour);
        //text_colour = colour; // Save the last colour drawn
      }

      else // Fill in blank segments
    {
      tft.fillRect(20, 227-ii, 80, 3, HX8357_GREY);

    }

  }

  tft.setTextColor(colour, TFT_BLACK);
  tft.setTextDatum(TR_DATUM);
  tft.setTextPadding(215);

  tft.drawString(format(tomato), x, y, 7); // Value in middle
  tft.setTextDatum(TL_DATUM);

  tft.setTextPadding(21);

  //  return x + r;
}









/*
int ringMeter(int value, int vmin, int vmax, int x, int y, int r, char *units, byte scheme, long tomato)
 {
 // Minimum value of r is about 52 before value text intrudes on ring
 // drawing the text first is an option
 
 x += r; 
 y += r;   // Calculate coords of centre of ring
 
 int w = r / 3;    // Width of outer ring is 1/4 of radius
 
 int angle = 150;  // Half the sweep angle of meter (300 degrees)
 
 int v = map(value, vmin, vmax, -angle, angle); // Map the value to an angle v
 
 byte seg = 3; // Segments are 3 degrees wide = 100 segments for 300 degrees
 byte inc = 6; // Draw segments every 3 degrees, increase to 6 for segmented ring
 int dtex = map((current.mpg()/10),vmin,vmax,-153,153);
 
 
 // Variable to save "value" text colour from scheme and set default
 int colour = TFT_BLUE;
 
 // Draw colour blocks every inc degrees
 
 
 //for (int i = -angle+inc/2; i < angle-inc/2; i += inc) {
 for (int i = -153; i < 153; i += inc) {
 // Calculate pair of coordinates for segment start
 float sx = cos((i - 90) * 0.0174532925);
 float sy = sin((i - 90) * 0.0174532925);
 uint16_t x0 = sx * (r - w) + x;
 uint16_t y0 = sy * (r - w) + y;
 uint16_t x1 = sx * r + x;
 uint16_t y1 = sy * r + y;
 
 // Calculate pair of coordinates for segment end
 float sx2 = cos((i + seg - 90) * 0.0174532925);
 float sy2 = sin((i + seg - 90) * 0.0174532925);
 int x2 = sx2 * (r - w) + x;
 int y2 = sy2 * (r - w) + y;
 int x3 = sx2 * r + x;
 int y3 = sy2 * r + y;
 
 
 if (i<=dtex&&i+6>=dtex){
 tft.fillTriangle(x0, y0, x1, y1, x2, y2, TFT_RED);
 tft.fillTriangle(x1, y1, x2, y2, x3, y3, TFT_RED);
 }
 else 
 
 if (i < v) { // Fill in coloured segments with 2 triangles
 switch (scheme) {
 case 0: 
 colour = TFT_RED; 
 break; // Fixed colour
 case 1: 
 colour = TFT_GREEN; 
 break; // Fixed colour
 case 2: 
 colour = TFT_BLUE; 
 break; // Fixed colour
 case 3: 
 colour = rainbow(map(i, -angle, angle, 0, 127)); 
 break; // Full spectrum blue to red
 case 4: 
 colour = rainbow(map(i, -angle, angle, 70, 127)); 
 break; // Green to red (high temperature etc)
 case 5: 
 colour = rainbow(map(i, -angle, angle, 127, 63)); 
 break; // Red to green (low battery etc)
 default: 
 colour = TFT_BLUE; 
 break; // Fixed colour
 }
 tft.fillTriangle(x0, y0, x1, y1, x2, y2, colour);
 tft.fillTriangle(x1, y1, x2, y2, x3, y3, colour);
 //text_colour = colour; // Save the last colour drawn
 }
 else // Fill in blank segments
 {
 tft.fillTriangle(x0, y0, x1, y1, x2, y2, HX8357_GREY);
 tft.fillTriangle(x1, y1, x2, y2, x3, y3, HX8357_GREY);
 }
 }
 // Convert value to a string
 char buf[10];
 byte len = 3; 
 if (value > 999) len = 5;
 dtostrf((value/10), len, 0, buf);
 buf[len] = ' '; 
 buf[len+1] = 0; // Add blanking space and terminator, helps to centre text too!
 // Set the text colour to default
 tft.setTextSize(1);
 
 if (value<vmin || value>vmax) {
 drawAlert(x,y+60,50,1);
 }
 else {
 drawAlert(x,y+60,50,0);
 }
 
 // Uncomment next line to set the text colour to the last segment value!
 tft.setTextColor(colour, TFT_BLACK);
 tft.setTextDatum(MC_DATUM);
 // Print value, if the meter is large then use big font 8, othewise use 4
 tft.setTextPadding(130);
 
 tft.drawString(format(tomato), x-5, y, 4); // Value in middle
 
 
 
 
 
 tft.setTextSize(1);
 tft.setTextPadding(0);
 // Print units, if the meter is large then use big font 4, othewise use 2
 
 
 
 
 
 
 // Calculate and return right hand side x coordinate
 return x + r;
 }
 */




int ringMeter(int value, int vmin, int vmax, int x, int y, int r, char *units, byte scheme, long tomato)
{
  // Minimum value of r is about 52 before value text intrudes on ring
  // drawing the text first is an option

  x += r; 
  y += r;   // Calculate coords of centre of ring

  int w = r / 3;    // Width of outer ring is 1/4 of radius

  int angle = 150;  // Half the sweep angle of meter (300 degrees)

  int v = map(value, vmin, vmax, -angle, angle); // Map the value to an angle v
  int dtex = map((current.mpg()/10),vmin,vmax,-angle,angle);

  byte seg = 3; // Segments are 3 degrees wide = 100 segments for 300 degrees
  byte inc = 6; // Draw segments every 3 degrees, increase to 6 for segmented ring

  // Variable to save "value" text colour from scheme and set default
  int colour = TFT_BLUE;

  // Draw colour blocks every inc degrees
  for (int i = -angle+inc/2; i < angle-inc/2; i += inc) {
    // Calculate pair of coordinates for segment start
    float sx = cos((i - 90) * 0.0174532925);
    float sy = sin((i - 90) * 0.0174532925);
    uint16_t x0 = sx * (r - w) + x;
    uint16_t y0 = sy * (r - w) + y;
    uint16_t x1 = sx * r + x;
    uint16_t y1 = sy * r + y;

    // Calculate pair of coordinates for segment end
    float sx2 = cos((i + seg - 90) * 0.0174532925);
    float sy2 = sin((i + seg - 90) * 0.0174532925);
    int x2 = sx2 * (r - w) + x;
    int y2 = sy2 * (r - w) + y;
    int x3 = sx2 * r + x;
    int y3 = sy2 * r + y;

    if (i<=dtex&&i+5>=dtex){
      tft.fillTriangle(x0, y0, x1, y1, x2, y2, TFT_RED);
      tft.fillTriangle(x1, y1, x2, y2, x3, y3, TFT_RED);
    }
    else if (i < v) { // Fill in coloured segments with 2 triangles
      switch (scheme) {
      case 0: 
        colour = TFT_RED; 
        break; // Fixed colour
      case 1: 
        colour = TFT_GREEN; 
        break; // Fixed colour
      case 2: 
        colour = TFT_BLUE; 
        break; // Fixed colour
      case 3: 
        colour = rainbow(map(i, -angle, angle, 0, 127)); 
        break; // Full spectrum blue to red
      case 4: 
        colour = rainbow(map(i, -angle, angle, 70, 127)); 
        break; // Green to red (high temperature etc)
      case 5: 
        colour = rainbow(map(i, -angle, angle, 127, 63)); 
        break; // Red to green (low battery etc)
      default: 
        colour = TFT_BLUE; 
        break; // Fixed colour
      }
      tft.fillTriangle(x0, y0, x1, y1, x2, y2, colour);
      tft.fillTriangle(x1, y1, x2, y2, x3, y3, colour);
      //text_colour = colour; // Save the last colour drawn
    }
    else // Fill in blank segments
    {
      tft.fillTriangle(x0, y0, x1, y1, x2, y2, HX8357_GREY);
      tft.fillTriangle(x1, y1, x2, y2, x3, y3, HX8357_GREY);
    }
  }
  // Convert value to a string
  char buf[10];
  byte len = 3; 
  if (value > 999) len = 5;
  dtostrf((value/10), len, 0, buf);
  buf[len] = ' '; 
  buf[len+1] = 0; // Add blanking space and terminator, helps to centre text too!
  // Set the text colour to default
  tft.setTextSize(1);

  if(parms[currentTripResetTimeoutUSIdx]==2) {// L/100km units
    if (value<vmin || value>vmax) {
      drawAlert(x,y+90,50,1);
    }
    else {
      drawAlert(x,y+90,50,0);
    }
  }
  else{
    if (value>vmin || value<vmax) {
      drawAlert(x,y+90,50,1);
    }
    else {
      drawAlert(x,y+90,50,0);
    }
  }

  tft.setTextColor(TFT_WHITE, TFT_BLACK);
  // Uncomment next line to set the text colour to the last segment value!
  tft.setTextColor(colour, TFT_BLACK);
  tft.setTextDatum(MC_DATUM);
  // Print value, if the meter is large then use big font 8, othewise use 4
  tft.setTextPadding(130);

  tft.drawString(format(tomato), x-5, y, 4); // Value in middle

  tft.setTextSize(1);
  tft.setTextPadding(0);
  // Print units, if the meter is large then use big font 4, othewise use 2
  // Calculate and return right hand side x coordinate
  return x + r;
}




void drawAlert(int x, int y , int side, boolean draw)
{
  if (draw && !alert) {
    if (instant.injPulses==0) {
      tft.fillCircle(x, y, 20, rainbow(60));
    }
    else {
      tft.fillCircle(x, y, 20, rainbow(127));
    }
    tft.setTextColor(TFT_BLACK);
    tft.drawCentreString("!", x, y-10 , 4);
    // alert = 1;
  }
  else if (!draw) {
    tft.fillCircle(x, y, 20, TFT_BLACK);
    alert = 0;
  }
}

// #########################################################################
// Return a 16 bit rainbow colour
// #########################################################################
unsigned int rainbow(byte value)
{
  // Value is expected to be in range 0-127
  // The value is converted to a spectrum colour from 0 = blue through to 127 = red

  byte red = 0; // Red is the top 5 bits of a 16 bit colour value
  byte green = 0;// Green is the middle 6 bits
  byte blue = 0; // Blue is the bottom 5 bits

  byte quadrant = value / 32;

  if (quadrant == 0) {
    blue = 31;
    green = 2 * (value % 32);
    red = 0;
  }
  if (quadrant == 1) {
    blue = 31 - (value % 32);
    green = 63;
    red = 0;
  }
  if (quadrant == 2) {
    blue = 0;
    green = 63;
    red = value % 32;
  }
  if (quadrant == 3) {
    blue = 0;
    green = 63 - 2 * (value % 32);
    red = 31;
  }
  return (red << 11) + (green << 5) + blue;
}







unsigned long getDTE(void){
  unsigned long dte;
  unsigned long fuel_remaining;
  fuel_remaining = parms[tankSizeIdx] - tank.gallons()+fueladd;
  if (parms[currentTripResetTimeoutUSIdx] == 2){


    init64(tmp10,0,fuel_remaining);
    init64(tmp20,0,1000000);
    mul64(tmp10,tmp20);

    init64(tmp20,0,current.mpgdte());
    div64(tmp10,tmp20); //something here does not work...

    if ((parms[tankSizeIdx]+fueladd) <= tank.gallons()) return 0;
    else
      return tmp10[1];

  }
  else{
    dte = ((fuel_remaining * current.mpgdte()) / 100000)*100;
    return dte;

  }
} 









//Trip::Trip(){      
//}      


unsigned long instantmph(){  
  //unsigned long vssPulseTimeuS = (lastVSS1 + lastVSS2) / 2;
  unsigned long vssPulseTimeuS = instant.vssPulseLength/instant.vssPulses;

  init64(tmp1,0,1000000000ul);
  init64(tmp2,0,parms[vssPulsesPerMileIdx]);
  div64(tmp1,tmp2);
  init64(tmp2,0,3600);
  mul64(tmp1,tmp2);
  init64(tmp2,0,vssPulseTimeuS);
  div64(tmp1,tmp2);

  return tmp1[1];
}

unsigned long instantmpg(){     
  unsigned long imph=instantmph();
  unsigned long igph=instantgph();

  if(parms[currentTripResetTimeoutUSIdx]==2){ // km
    if(imph == 0) return 999999000;
    if(igph == 0) return 0;
  }
  else{ // miles
    if(imph == 0) return 0;
    if(igph == 0) return 999999000;  
  }
  init64(tmp1,0,1000ul);
  init64(tmp2,0,imph);
  mul64(tmp1,tmp2);
  init64(tmp2,0,igph);
  div64(tmp1,tmp2);

  if(parms[currentTripResetTimeoutUSIdx]==2){ // km
    //convert km/L to L/100km
    init64(tmp2,0,100000000ul);
    div64(tmp2,tmp1);
    return tmp2[1];
  }
  else {
    return tmp1[1];
  }
}

unsigned long instantgph(){      
  //  unsigned long vssPulseTimeuS = instant.vssPulseLength/instant.vssPulses;

  //  unsigned long instInjStart=nil; 
  //unsigned long instInjEnd; 
  //unsigned long instInjTot; 
  init64(tmp1,0,instInjTot);
  init64(tmp2,0,3600000000ul);
  mul64(tmp1,tmp2);
  init64(tmp2,0,1000ul);
  mul64(tmp1,tmp2);
  init64(tmp2,0,parms[microSecondsPerGallonIdx]);
  div64(tmp1,tmp2);
  init64(tmp2,0,instInjEnd-instInjStart);
  div64(tmp1,tmp2);
  return tmp1[1];      
}

unsigned long instantrpm(){      
  init64(tmp1,0,instInjCount);
  init64(tmp2,0,120000000ul);
  mul64(tmp1,tmp2);
  init64(tmp2,0,1000ul);
  mul64(tmp1,tmp2);
  init64(tmp2,0,parms[injPulsesPer2Revolutions]);
  div64(tmp1,tmp2);
  init64(tmp2,0,instInjEnd-instInjStart);
  div64(tmp1,tmp2);

  return (tmp1[1] / 10000)*10000; //make last digit to be 0
  //return tmp1[1];
} 

unsigned long Trip::miles(){      
  init64(tmp1,0,vssPulses);
  init64(tmp2,0,1000);
  mul64(tmp1,tmp2);
  init64(tmp2,0,parms[vssPulsesPerMileIdx]);
  div64(tmp1,tmp2);
  return tmp1[1];      
}      

unsigned long Trip::eocMiles(){      
  init64(tmp1,0,vssEOCPulses);
  init64(tmp2,0,1000);
  mul64(tmp1,tmp2);
  init64(tmp2,0,parms[vssPulsesPerMileIdx]);
  div64(tmp1,tmp2);
  return tmp1[1];      
}       

unsigned long Trip::mph(){      
  if(loopCount == 0)     
    return 0;     
  init64(tmp1,0,loopsPerSecond);
  init64(tmp2,0,vssPulses);
  mul64(tmp1,tmp2);
  init64(tmp2,0,3600000);
  mul64(tmp1,tmp2);
  init64(tmp2,0,parms[vssPulsesPerMileIdx]);
  div64(tmp1,tmp2);
  init64(tmp2,0,loopCount);
  div64(tmp1,tmp2);
  return tmp1[1];      
}

unsigned long  Trip::gallons(){      
  init64(tmp1,0,injHiSec);
  init64(tmp2,0,1000000);
  mul64(tmp1,tmp2);
  init64(tmp2,0,injHius);
  add64(tmp1,tmp2);
  init64(tmp2,0,1000);
  mul64(tmp1,tmp2);
  init64(tmp2,0,parms[microSecondsPerGallonIdx]);
  div64(tmp1,tmp2);
  return tmp1[1];      
}      
/*
unsigned long  Trip::idleGallons(){      
 init64(tmp1,0,injIdleHiSec);
 init64(tmp2,0,1000000);
 mul64(tmp1,tmp2);
 init64(tmp2,0,injIdleHius);
 add64(tmp1,tmp2);
 init64(tmp2,0,1000);
 mul64(tmp1,tmp2);
 init64(tmp2,0,parms[microSecondsPerGallonIdx]);
 div64(tmp1,tmp2);
 return tmp1[1];      
 }      
 */
//eocMiles
//idleGallons

unsigned long  Trip::mpg(){
  if(parms[currentTripResetTimeoutUSIdx]==2) {// km
    if(vssPulses==0) return 999999000;      
    if(injPulses==0) return 0;
  }
  else{ // miles
    if(vssPulses==0) return 0;      
    if(injPulses==0) return 999999000; //who doesn't like to see 999999?  :)    
  }

  init64(tmp1,0,injHiSec);
  init64(tmp3,0,1000000);
  mul64(tmp3,tmp1);
  init64(tmp1,0,injHius);
  add64(tmp3,tmp1);
  init64(tmp1,0,parms[vssPulsesPerMileIdx]);
  mul64(tmp3,tmp1);

  init64(tmp1,0,parms[microSecondsPerGallonIdx]);
  init64(tmp2,0,1000);
  mul64(tmp1,tmp2);
  init64(tmp2,0,vssPulses);
  mul64(tmp1,tmp2);

  div64(tmp1,tmp3);

  if(parms[currentTripResetTimeoutUSIdx]==2){ // km
    //convert km/L to L/100km
    init64(tmp2,0,100000000ul);
    div64(tmp2,tmp1);
    return tmp2[1];
  }
  else {
    return tmp1[1];
  }
}     

unsigned long  Trip::mpgdte(){
  if(parms[currentTripResetTimeoutUSIdx]==2){ // km
    if(vssPulses==0) return 999999000;      
    if(injPulses==0) return 0;
  }
  else{ // miles
    if(vssPulses==0) return 0;      
    if(injPulses==0) return 999999000; //who doesn't like to see 999999?  :)    
  }
  init64(tmp1,0,injHiSec);
  init64(tmp3,0,1000000);
  mul64(tmp3,tmp1);
  init64(tmp1,0,injHius);
  add64(tmp3,tmp1);
  init64(tmp1,0,parms[vssPulsesPerMileIdx]);
  mul64(tmp3,tmp1);

  init64(tmp1,0,parms[microSecondsPerGallonIdx]);
  init64(tmp2,0,1000);
  mul64(tmp1,tmp2);
  init64(tmp2,0,vssPulses);
  mul64(tmp1,tmp2);

  div64(tmp1,tmp3);

  if(parms[currentTripResetTimeoutUSIdx]==2){ // km
    //convert km/L to L/100km
    init64(tmp2,0,1000000000ul);
    div64(tmp2,tmp1);
    return tmp2[1];
  }
  else{ 
    return tmp1[1];
  } 
}   





void Trip::reset(){      
  loopCount = 0;      
  injPulses = 0;      
  injHius = 0;      
  injHiSec = 0;      
  vssPulses = 0;  
  vssPulseLength = 0;
  injIdleHiSec = 0;
  injIdleHius = 0;
  vssEOCPulses = 0;

}      

void Trip::update(Trip t) {
  if(t.vssPulses || t.injPulses) { 
    loopCount++;  //we call update once per loop
  }
  vssPulses += t.vssPulses;      
  vssPulseLength += t.vssPulseLength;
  if ( t.injPulses == 0 )  //track distance traveled with engine off
    vssEOCPulses += t.vssPulses;

  if ( t.injPulses > 2 && t.injHius < 500000 ) {// chasing ghosts      
    injPulses += t.injPulses;      
    injHius += t.injHius;      
    if (injHius >= 1000000){  
      // rollover into the injHiSec counter      
      injHiSec++;      
      injHius -= 1000000;      
    }
    if(t.vssPulses == 0) {    
      // track gallons spent sitting still
      injIdleHius += t.injHius;      
      if (injIdleHius >= 1000000) {  //r
        injIdleHiSec++;
        injIdleHius -= 1000000;      
      }      
    }
  }      
}   




int insert(int *array, int val, size_t size, size_t at)
{
  size_t i;

  /* In range? */
  if (at >= size)
    return -1;

  /* Shift elements to make a hole */
  for (i = size - 1; i > at; i--)
    array[i] = array[i - 1];
  /* Insertion! */
  array[at] = val;

  return 0;
}

void save(){
  if (oldset!=parms[currentTripResetTimeoutUSIdx]) convert();
  EEPROM.write(0,guinosig);
  EEPROM.write(1,mylength(parms));
  writeEepBlock32(0x04, &parms[0], mylength(parms));

}

void writeEepBlock32(unsigned int start_addr, unsigned long *val, unsigned int size) {
  unsigned char p = 0;
  unsigned char shift = 0;
  int i = 0;
  for(start_addr; p < size; start_addr+=4) {
    for (i=0; i<4; i++) {
      shift = (8 * (3-i));  /* 24, 16, 8, 0 */
      EEPROM.write(start_addr + i, (val[p]>>shift) & 0xFF);
    }
    p++;
  }
}

void readEepBlock32(unsigned int start_addr, unsigned long *val, unsigned int size) {
  unsigned long v = 0;
  unsigned char p = 0;
  unsigned char temp = 0;
  unsigned char i = 0;
  for(start_addr; p < size; start_addr+=4) {
    v = 0;   /* clear the scratch variable every loop! */
    for (i=0; i<4; i++) {
      temp = (i > 0) ? 1 : 0;  /* 0, 1, 1, 1  */
      v = (v << (temp * 8)) + EEPROM.read(start_addr + i);
    }
    val[p] = v;
    p++;
  }
}

//#if (TANK_IN_EEPROM_CFG == 1)
void saveTankData() {
  tank.loopCount=fueladd;
  unsigned long var[] = {
    //current.loopCount,
    current.injPulses,
    current.injHiSec,
    current.injHius,
    //   tank.injIdleHiSec,
    //   tank.injIdleHius,
    current.vssPulses,
    //  tank.vssPulseLength,
    tank.loopCount,
    tank.injPulses,
    tank.injHiSec,
    tank.injHius,
    //  current.injIdleHiSec,
    //  current.injIdleHius,
    tank.vssPulses
      //  current.vssPulseLength
  };
  writeEepBlock32(eepBlkAddr_Tank, &var[0], eepBlkSize_Tank);
}

void loadTankData() {
  unsigned long var[9];
  readEepBlock32(eepBlkAddr_Tank, &var[0], eepBlkSize_Tank);
  //current.loopCount = var[0];
  current.injPulses = var[0];
  current.injHiSec = var[1];
  current.injHius = var[2];
  // tank.injIdleHiSec = var[4];
  // tank.injIdleHius = var[5];
  current.vssPulses = var[3];
  // tank.vssPulseLength = var[5];
  tank.loopCount = var[4];
  tank.injPulses = var[5];
  tank.injHiSec = var[6];
  tank.injHius = var[7];
  // current.injIdleHiSec = var[12];
  // current.injIdleHius = var[13];
  tank.vssPulses = var[8];
  // current.vssPulseLength = var[11];
  fueladd=tank.loopCount;
}
//#endif

unsigned char load(){ //return 1 if loaded ok
#ifdef usedefaults
  return 1;
#endif
  unsigned char b = EEPROM.read(0);
  unsigned char c = EEPROM.read(1);
  if(b == guinosigold)
    c=9; //before fancy parameter counter

  if(b == guinosig || b == guinosigold){
    readEepBlock32(0x04, &parms[0], mylength(parms));
    //#if (TANK_IN_EEPROM_CFG == 1)
    /* read out the tank variables on boot */
    /* TODO:  eepBlkSize_Tank is appropriate for size? */
    // readEepBlock32(eepBlkAddr_Tank, &tank.var[0], eepBlkSize_Tank);
    loadTankData();
    //#endif
    return 1;
  }
  return 0;
}

char * uformat(unsigned long val){ 
  static char mBuff[17];
  unsigned long d = 1000000000ul;
  unsigned char p;
  for(p = 0; p < 10 ; p++){
    mBuff[p]='0' + (val/d);
    val=val-(val/d*d);
    d/=10;
  }
  mBuff[10]=0;
  return mBuff;
} 

unsigned long rformat(char * val){ 
  unsigned long d = 1000000000ul;
  unsigned long v = 0ul;
  for(unsigned char p = 0; p < 10 ; p++){
    v=v+(d*(val[p]-'0'));
    d/=10;
  }
  return v;
} 


boolean editParm(unsigned char parmIdx){


  if (parmIdx==4) oldset=parms[currentTripResetTimeoutUSIdx];
  unsigned long v = parms[parmIdx];
  unsigned char p=11;  //right end of 10 digit number
  unsigned char keyLock=1;    
  long xss,yss;
  char *fmtv = uformat(v);
  tft.setTextDatum(TL_DATUM);

  /* -- line 1 -- */
  if (parms[currentTripResetTimeoutUSIdx]==2){
    tft.drawString(parmLabelsM[parmIdx], 10, 30, 4);
  }
  else{
    tft.drawString(parmLabels[parmIdx], 10, 30, 4);    
  };
  tft.drawString("OK   EXIT",166,70,4);



  tft.fillRect(   20,188,40,8,TFT_WHITE);
  tft.fillRect(   121,167,8,50,TFT_WHITE);
  tft.fillRect(   191,167,8,50,TFT_WHITE);
  tft.fillRect(   260,188,40,8,TFT_WHITE);

  tft.drawLine( 125,149,115,168,TFT_WHITE);
  tft.drawLine( 125,149,116,168,TFT_WHITE);
  tft.drawLine( 125,149,117,168,TFT_WHITE);
  tft.drawLine( 125,149,118,168,TFT_WHITE);
  tft.drawLine( 125,149,119,168,TFT_WHITE);
  tft.drawLine( 125,149,120,168,TFT_WHITE);
  tft.drawLine( 125,149,121,168,TFT_WHITE);
  tft.drawLine( 125,149,122,168,TFT_WHITE);
  tft.drawLine( 125,149,123,168,TFT_WHITE);
  tft.drawLine( 125,149,124,168,TFT_WHITE);
  tft.drawLine( 125,149,125,168,TFT_WHITE);
  tft.drawLine( 125,149,126,168,TFT_WHITE);
  tft.drawLine( 125,149,127,168,TFT_WHITE);
  tft.drawLine( 125,149,128,168,TFT_WHITE);
  tft.drawLine( 125,149,129,168,TFT_WHITE);
  tft.drawLine( 125,149,130,168,TFT_WHITE);
  tft.drawLine( 125,149,131,168,TFT_WHITE);
  tft.drawLine( 125,149,132,168,TFT_WHITE);
  tft.drawLine( 125,149,133,168,TFT_WHITE);
  tft.drawLine( 125,149,134,168,TFT_WHITE);
  // tft.drawLine( 125,150,135,170,TFT_WHITE);


  tft.drawLine( 195,235,185,216,TFT_WHITE);
  tft.drawLine( 195,235,186,216,TFT_WHITE);
  tft.drawLine( 195,235,187,216,TFT_WHITE);
  tft.drawLine( 195,235,188,216,TFT_WHITE);
  tft.drawLine( 195,235,189,216,TFT_WHITE);
  tft.drawLine( 195,235,190,216,TFT_WHITE);
  tft.drawLine( 195,235,191,216,TFT_WHITE);
  tft.drawLine( 195,235,192,216,TFT_WHITE);
  tft.drawLine( 195,235,193,216,TFT_WHITE);
  tft.drawLine( 195,235,194,216,TFT_WHITE);
  tft.drawLine( 195,235,195,216,TFT_WHITE);
  tft.drawLine( 195,235,196,216,TFT_WHITE);
  tft.drawLine( 195,235,197,216,TFT_WHITE);
  tft.drawLine( 195,235,198,216,TFT_WHITE);
  tft.drawLine( 195,235,199,216,TFT_WHITE);
  tft.drawLine( 195,235,200,216,TFT_WHITE);
  tft.drawLine( 195,235,201,216,TFT_WHITE);
  tft.drawLine( 195,235,202,216,TFT_WHITE);
  tft.drawLine( 195,235,203,216,TFT_WHITE);
  tft.drawLine( 195,235,204,216,TFT_WHITE);

  tft.drawLine( 5,192,25,182,TFT_WHITE);
  tft.drawLine( 5,192,25,183,TFT_WHITE);
  tft.drawLine( 5,192,25,184,TFT_WHITE);
  tft.drawLine( 5,192,25,185,TFT_WHITE);
  tft.drawLine( 5,192,25,186,TFT_WHITE);
  tft.drawLine( 5,192,25,187,TFT_WHITE);
  tft.drawLine( 5,192,25,188,TFT_WHITE);
  tft.drawLine( 5,192,25,189,TFT_WHITE);
  tft.drawLine( 5,192,25,190,TFT_WHITE);
  tft.drawLine( 5,192,25,191,TFT_WHITE);
  tft.drawLine( 5,192,25,192,TFT_WHITE);
  tft.drawLine( 5,192,25,193,TFT_WHITE);
  tft.drawLine( 5,192,25,194,TFT_WHITE);
  tft.drawLine( 5,192,25,195,TFT_WHITE);
  tft.drawLine( 5,192,25,196,TFT_WHITE);
  tft.drawLine( 5,192,25,197,TFT_WHITE);
  tft.drawLine( 5,192,25,198,TFT_WHITE);
  tft.drawLine( 5,192,25,199,TFT_WHITE);
  tft.drawLine( 5,192,25,200,TFT_WHITE);
  tft.drawLine( 5,192,25,201,TFT_WHITE);
  tft.drawLine( 5,192,25,202,TFT_WHITE);
  tft.drawLine( 5,192,25,203,TFT_WHITE);
  // tft.drawLine( 5,192,25,204,TFT_WHITE);



  tft.drawLine(295,182,315,192,TFT_WHITE);
  tft.drawLine(295,183,315,192,TFT_WHITE);
  tft.drawLine(295,184,315,192,TFT_WHITE);
  tft.drawLine(295,185,315,192,TFT_WHITE);
  tft.drawLine(295,186,315,192,TFT_WHITE);
  tft.drawLine(295,187,315,192,TFT_WHITE);
  tft.drawLine(295,188,315,192,TFT_WHITE);
  tft.drawLine(295,189,315,192,TFT_WHITE);
  tft.drawLine(295,190,315,192,TFT_WHITE);
  tft.drawLine(295,191,315,192,TFT_WHITE);
  tft.drawLine(295,192,315,192,TFT_WHITE);
  tft.drawLine(295,193,315,192,TFT_WHITE);
  tft.drawLine(295,194,315,192,TFT_WHITE);
  tft.drawLine(295,195,315,192,TFT_WHITE);
  tft.drawLine(295,196,315,192,TFT_WHITE);
  tft.drawLine(295,197,315,192,TFT_WHITE);
  tft.drawLine(295,198,315,192,TFT_WHITE);
  tft.drawLine(295,199,315,192,TFT_WHITE);
  tft.drawLine(295,200,315,192,TFT_WHITE);
  tft.drawLine(295,201,315,192,TFT_WHITE);
  tft.drawLine(295,202,315,192,TFT_WHITE);
  tft.drawLine(295,203,315,192,TFT_WHITE);

  /* -- line 2 -- */
  tft.drawString(fmtv,10,70,4);

  /* -- turn the cursor on -- */
  //   LCD::LcdCommandWrite(LCD_DisplayOnOffCtrl | LCD_DisplayOnOffCtrl_DispOn | LCD_DisplayOnOffCtrl_CursOn);
  /* cursor on 'OK' by default except for contrast */
  (parmIdx == contrastIdx) ? p=9 : p=10;  

  while(true){


    tft.drawLine(9,91,330,91,TFT_BLACK);
    tft.drawLine(9,92,330,92,TFT_BLACK);
    if (p==10){
      tft.drawLine(165,91,205,91,TFT_WHITE);  //blue
      tft.drawLine(165,92,205,92,TFT_WHITE);  //blue
    }
    else
      if (p==11){
        tft.drawLine(216,91,270,91,TFT_WHITE);  //blue
        tft.drawLine(216,92,270,92,TFT_WHITE);  //blue
      }
    else{
      tft.drawLine(9+(14*(p)),91,9+(14*(p))+15,91,TFT_WHITE);  //blue
      tft.drawLine(9+(14*(p)),92,9+(14*(p))+15,92,TFT_WHITE);  //blue
    }

    tft.setCursor(0, 0);      

    myTouch.read();

    xss = myTouch.getX();
    yss = myTouch.getY();
    if (touchorient==0){ 
      xss=320-xss;
      yss=240-yss;
    }
    //press ok straight
    if (yss>=60 && yss<=125){
      if (parmIdx!=0 && parmIdx!=4 && parmIdx!=8) {
        if (xss>=10 && xss<=23) p=0;
        if (xss>=23 && xss<=36) p=1;
        if (xss>=38 && xss<=51) p=2;
        if (xss>=52 && xss<=63) p=3;
        if (xss>=66 && xss<=79) p=4;
        if (xss>=80 && xss<=93) p=5;
        if (xss>=94 && xss<=107) p=6;
        if (xss>=108 && xss<=121) p=7;
      }
      if (xss>=122 && xss<=135) p=8;

      if (xss>=136 && xss<=149) p=9;

      if (xss>=162 && xss<=205){
        p=10;
        cp=cp+1;
        if (cp>=6) {
          cp=0;
          parms[parmIdx]=rformat(fmtv);
          //   LCD::LcdCommandWrite(B00001100); //cursor off
          tft.fillScreen(TFT_BLACK);

          SCREEN=tempscreen;
          delay2(250);
          return true;
        }
      }
      if (xss>=211 && xss<=275){
        p=11;
        cp=cp+1;
        if (cp>=6) {
          cp=0;
          tft.fillScreen(TFT_BLACK);
          SCREEN=tempscreen;
          delay2(250);
          return false;
        }
      }
    }

    if (yss>=150){   
      if (xss>=0 && xss<=70){
        cp=cp+1;
        if (cp>=2) {
          p--;
          if (parmIdx==0) if(p==8)p=11;
          if (parmIdx==4) if(p==8)p=11;
          if (parmIdx==8) if(p==8)p=11;
          if(p==255)p=11;
          cp=0;
        }
      };
      if (xss>=85 && xss<=155){
        cp=cp+1;
        if (cp>=2) { 
          {
            ;
            cp=0;
            if(p==10){  //ok selected
              parms[parmIdx]=rformat(fmtv);
              //   LCD::LcdCommandWrite(B00001100); //cursor off
              tft.fillScreen(TFT_BLACK);

              SCREEN=tempscreen;
              delay2(250);
              return true;
            }
            else if(p==11){  //cancel selected
              //    LCD::LcdCommandWrite(B00001100); //cursor off
              tft.fillScreen(TFT_BLACK);
              SCREEN=tempscreen;
              delay2(250);
              return false;
            }   			 

            unsigned char n = fmtv[p]-'0';
            n++;
            if (n > 9) n=0;
            if(p==0 && n > 3) n=0;

            if (parmIdx==0) if (rformat(fmtv)>=1) n=0;
            if (parmIdx==4) if (rformat(fmtv)>=2) n=1;
            if (parmIdx==8) if (rformat(fmtv)>=2) n=0;

            fmtv[p]='0'+ n;

            //   LCD::gotoXY(0,1);        
            //    LCD::print(fmtv);
            //   LCD::gotoXY(p,1);  
            tft.drawString(fmtv,10,70,4);
          }  
        }
      };
      if (xss>=165 && xss<=236 && p<=9){
        cp=cp+1;
        if (cp>=2){
          cp=0;
          unsigned char n = fmtv[p]-'0';
          n--;
          if (n ==255 ) n=9;
          if(p==0 && n > 3) n=0;
          if (parmIdx==0) if (n>=2) n=1;
          if (parmIdx==4) if (n>=3) n=2;
          if (parmIdx==4) if (n==0) n=2;
          if (parmIdx==8) if (n>=3) n=2;
          fmtv[p]='0'+ n;
          //   LCD::gotoXY(0,1);        
          //    LCD::print(fmtv);
          //   LCD::gotoXY(p,1);  
          tft.drawString(fmtv,10,70,4);
        }
      }
      if (xss>=250 && xss<=318){
        cp=cp+1;
        if (cp>=2) {
          p++;
          if (parmIdx==0) if(p==12)p=9;
          if (parmIdx==4) if(p==12)p=9;
          if (parmIdx==8) if(p==12)p=9;
          if(p==12)p=0;
          cp=0;
        }
      };
    }
    if (xss==-1) cp=0;  
    if (xss==321) cp=0;  
    delay2(35);
  }


}

boolean configFill(unsigned char parmIdx){
  unsigned long v = parms[parmIdx];
  long xss,yss;
  float recty;
  //int rectyy;
  unsigned char p=5;  //right end of 10 digit number
  unsigned char keyLock=1;    

  char *fmtv = uformat(tank.gallons()-fueladd);
  tft.setTextDatum(TL_DATUM);

  /* -- line 1 -- */
  tft.drawString("Correct amount of fuel filled:", 10, 30, 4);
  tft.drawString("OK   EXIT",166,70,4);
  tft.setTextPadding(16);

  if(parms[currentTripResetTimeoutUSIdx]==2){ // L/100km units
    tft.drawString("L",10+(14*(9)),70,4);
  }
  else{
    tft.drawString("G",10+(14*(9)),70,4);
  }  

  tft.fillRect(   20,188,40,8,TFT_WHITE);
  tft.fillRect(   121,167,8,50,TFT_WHITE);
  tft.fillRect(   191,167,8,50,TFT_WHITE);
  tft.fillRect(   260,188,40,8,TFT_WHITE);

  tft.drawLine( 125,149,115,168,TFT_WHITE);
  tft.drawLine( 125,149,116,168,TFT_WHITE);
  tft.drawLine( 125,149,117,168,TFT_WHITE);
  tft.drawLine( 125,149,118,168,TFT_WHITE);
  tft.drawLine( 125,149,119,168,TFT_WHITE);
  tft.drawLine( 125,149,120,168,TFT_WHITE);
  tft.drawLine( 125,149,121,168,TFT_WHITE);
  tft.drawLine( 125,149,122,168,TFT_WHITE);
  tft.drawLine( 125,149,123,168,TFT_WHITE);
  tft.drawLine( 125,149,124,168,TFT_WHITE);
  tft.drawLine( 125,149,125,168,TFT_WHITE);
  tft.drawLine( 125,149,126,168,TFT_WHITE);
  tft.drawLine( 125,149,127,168,TFT_WHITE);
  tft.drawLine( 125,149,128,168,TFT_WHITE);
  tft.drawLine( 125,149,129,168,TFT_WHITE);
  tft.drawLine( 125,149,130,168,TFT_WHITE);
  tft.drawLine( 125,149,131,168,TFT_WHITE);
  tft.drawLine( 125,149,132,168,TFT_WHITE);
  tft.drawLine( 125,149,133,168,TFT_WHITE);
  tft.drawLine( 125,149,134,168,TFT_WHITE);
  // tft.drawLine( 125,150,135,170,TFT_WHITE);


  tft.drawLine( 195,235,185,216,TFT_WHITE);
  tft.drawLine( 195,235,186,216,TFT_WHITE);
  tft.drawLine( 195,235,187,216,TFT_WHITE);
  tft.drawLine( 195,235,188,216,TFT_WHITE);
  tft.drawLine( 195,235,189,216,TFT_WHITE);
  tft.drawLine( 195,235,190,216,TFT_WHITE);
  tft.drawLine( 195,235,191,216,TFT_WHITE);
  tft.drawLine( 195,235,192,216,TFT_WHITE);
  tft.drawLine( 195,235,193,216,TFT_WHITE);
  tft.drawLine( 195,235,194,216,TFT_WHITE);
  tft.drawLine( 195,235,195,216,TFT_WHITE);
  tft.drawLine( 195,235,196,216,TFT_WHITE);
  tft.drawLine( 195,235,197,216,TFT_WHITE);
  tft.drawLine( 195,235,198,216,TFT_WHITE);
  tft.drawLine( 195,235,199,216,TFT_WHITE);
  tft.drawLine( 195,235,200,216,TFT_WHITE);
  tft.drawLine( 195,235,201,216,TFT_WHITE);
  tft.drawLine( 195,235,202,216,TFT_WHITE);
  tft.drawLine( 195,235,203,216,TFT_WHITE);
  tft.drawLine( 195,235,204,216,TFT_WHITE);

  tft.drawLine( 5,192,25,182,TFT_WHITE);
  tft.drawLine( 5,192,25,183,TFT_WHITE);
  tft.drawLine( 5,192,25,184,TFT_WHITE);
  tft.drawLine( 5,192,25,185,TFT_WHITE);
  tft.drawLine( 5,192,25,186,TFT_WHITE);
  tft.drawLine( 5,192,25,187,TFT_WHITE);
  tft.drawLine( 5,192,25,188,TFT_WHITE);
  tft.drawLine( 5,192,25,189,TFT_WHITE);
  tft.drawLine( 5,192,25,190,TFT_WHITE);
  tft.drawLine( 5,192,25,191,TFT_WHITE);
  tft.drawLine( 5,192,25,192,TFT_WHITE);
  tft.drawLine( 5,192,25,193,TFT_WHITE);
  tft.drawLine( 5,192,25,194,TFT_WHITE);
  tft.drawLine( 5,192,25,195,TFT_WHITE);
  tft.drawLine( 5,192,25,196,TFT_WHITE);
  tft.drawLine( 5,192,25,197,TFT_WHITE);
  tft.drawLine( 5,192,25,198,TFT_WHITE);
  tft.drawLine( 5,192,25,199,TFT_WHITE);
  tft.drawLine( 5,192,25,200,TFT_WHITE);
  tft.drawLine( 5,192,25,201,TFT_WHITE);
  tft.drawLine( 5,192,25,202,TFT_WHITE);
  tft.drawLine( 5,192,25,203,TFT_WHITE);
  // tft.drawLine( 5,192,25,204,TFT_WHITE);



  tft.drawLine(295,182,315,192,TFT_WHITE);
  tft.drawLine(295,183,315,192,TFT_WHITE);
  tft.drawLine(295,184,315,192,TFT_WHITE);
  tft.drawLine(295,185,315,192,TFT_WHITE);
  tft.drawLine(295,186,315,192,TFT_WHITE);
  tft.drawLine(295,187,315,192,TFT_WHITE);
  tft.drawLine(295,188,315,192,TFT_WHITE);
  tft.drawLine(295,189,315,192,TFT_WHITE);
  tft.drawLine(295,190,315,192,TFT_WHITE);
  tft.drawLine(295,191,315,192,TFT_WHITE);
  tft.drawLine(295,192,315,192,TFT_WHITE);
  tft.drawLine(295,193,315,192,TFT_WHITE);
  tft.drawLine(295,194,315,192,TFT_WHITE);
  tft.drawLine(295,195,315,192,TFT_WHITE);
  tft.drawLine(295,196,315,192,TFT_WHITE);
  tft.drawLine(295,197,315,192,TFT_WHITE);
  tft.drawLine(295,198,315,192,TFT_WHITE);
  tft.drawLine(295,199,315,192,TFT_WHITE);
  tft.drawLine(295,200,315,192,TFT_WHITE);
  tft.drawLine(295,201,315,192,TFT_WHITE);
  tft.drawLine(295,202,315,192,TFT_WHITE);
  tft.drawLine(295,203,315,192,TFT_WHITE);
  //tft.drawLine(295,204,315,192,TFT_WHITE);
  //tft.drawLine(295,205,315,192,TFT_WHITE);
  // tft.drawLine(295,206,315,192,TFT_WHITE);
  /* -- line 2 -- */
  tft.drawString(fmtv,10,70,4);

  /* -- turn the cursor on -- */
  //   LCD::LcdCommandWrite(LCD_DisplayOnOffCtrl | LCD_DisplayOnOffCtrl_DispOn | LCD_DisplayOnOffCtrl_CursOn);
  /* cursor on 'OK' by default except for contrast */
  // (parmIdx == contrastIdx) ? p=8 : p=10;  

  while(true){
    //decimal
    tft.fillRect(10+(14*(7)),88,2,2,TFT_WHITE); 
    //  tft.fillRect(9+(14*(9)),70,15,21,TFT_BLACK); 
    tft.drawString("L",11+(14*(9)),70,4);

    tft.drawLine(9,91,330,91,TFT_BLACK);
    tft.drawLine(9,92,330,92,TFT_BLACK);
    if (p==10){
      tft.drawLine(165,91,205,91,TFT_WHITE);  //blue 
      tft.drawLine(165,92,205,92,TFT_WHITE);  //blue
    }
    else
      if (p==11){
        tft.drawLine(216,91,270,91,TFT_WHITE);  //blue 
        tft.drawLine(216,92,270,92,TFT_WHITE);  //blue 
      }
    else{
      tft.drawLine(9+(14*(p)),91,9+(14*(p))+15,91,TFT_WHITE);  //blue 
      tft.drawLine(9+(14*(p)),92,9+(14*(p))+15,92,TFT_WHITE);  //blue 
    }


    tft.setCursor(0, 0);

    myTouch.read();
    xss = myTouch.getX();
    yss = myTouch.getY();
    if (touchorient==0){ 
      xss=320-xss;
      yss=240-yss;
    }

    if (yss>=60 && yss<=125){
      //if (xss>=10 && xss<=23) p=0;
      //if (xss>=23 && xss<=36) p=1;
      //if (xss>=38 && xss<=51) p=2;
      //if (xss>=52 && xss<=63) p=3;
      // if (xss>=66 && xss<=79) p=4;
      if (xss>=80 && xss<=93) p=5;
      if (xss>=94 && xss<=107) p=6;
      if (xss>=108 && xss<=121) p=7;
      if (xss>=122 && xss<=135) {
        p=8;
        cp=0;
      }
      //if (xss>=136 && xss<=149) p=9;

      if (xss>=162 && xss<=205){
        p=10;
        cp=cp+1;
        if (cp>=6) {
          tft.fillScreen(TFT_BLACK);
          recty=(((float)parms[microSecondsPerGallonIdx])*(float)tank.gallons());
          recty=recty/(float)(rformat(fmtv)+fueladd);
          parms[microSecondsPerGallonIdx] =(long)recty;
          SCREEN=tempscreen;
          delay2(250);
          return true;

        }
      }
      if (xss>=211 && xss<=275){
        p=11;
        cp=cp+1;
        if (cp>=6) {
          cp=0;
          tft.fillScreen(TFT_BLACK);
          SCREEN=tempscreen;
          delay2(250);
          return false;
        }
      }
    }



    if (yss>=150){   
      if (xss>=0 && xss<=70){
        cp=cp+1;
        if (cp>=2) {
          p--;
          if(p==255)p=11;
          if(p==9)p=8;
          cp=0;
        }
      };
      if (xss>=85 && xss<=155){
        cp=cp+1;
        if (cp>=2) { 
          {
            ;
            cp=0;
            if(p==10){  //ok selected
              // parms[parmIdx]=rformat(fmtv);
              //   LCD::LcdCommandWrite(B00001100); //cursor off
              tft.fillScreen(TFT_BLACK);
              recty=(((float)parms[microSecondsPerGallonIdx])*(float)tank.gallons());
              recty=recty/(float)(rformat(fmtv)+fueladd);
              parms[microSecondsPerGallonIdx] =(long)recty;
              SCREEN=tempscreen;
              delay2(250);
              return true;
            }
            else if(p==11){  //cancel selected
              //    LCD::LcdCommandWrite(B00001100); //cursor off
              tft.fillScreen(TFT_BLACK);
              SCREEN=tempscreen;
              delay2(250);
              return false;
            }   			 

            unsigned char n = fmtv[p]-'0';
            n++;
            if (n > 9) n=0;
            if(p==0 && n > 3) n=0;
            fmtv[p]='0'+ n;
            //   LCD::gotoXY(0,1);        
            //    LCD::print(fmtv);
            //   LCD::gotoXY(p,1);  
            tft.drawString(fmtv,10,70,4);
          }  
        }
      };

      if (xss>=165 && xss<=236 && p<=9){
        cp=cp+1;
        if (cp>=2){
          cp=0;
          unsigned char n = fmtv[p]-'0';
          n--;
          if (n ==255 ) n=9;
          if(p==0 && n > 3) n=0;
          fmtv[p]='0'+ n;
          //   LCD::gotoXY(0,1);        
          //    LCD::print(fmtv);
          //   LCD::gotoXY(p,1);  
          tft.drawString(fmtv,10,70,4);
        }
      }
      if (xss>=250 && xss<=318){
        cp=cp+1;
        if (cp>=2) {
          p++;
          if(p==12)p=0;
          if(p==9)p=10;
          cp=0;
        }
      };
    }
    if (xss==-1) cp=0;  
    if (xss==321) cp=0;  







    delay2(35);
  }


}


boolean configFillcheck(unsigned char parmIdx){
  unsigned long v = parms[parmIdx];
  long xss,yss,recty;
  //int rectyy;
  unsigned char p=5;  //right end of 10 digit number
  unsigned char keyLock=1;    
  cp=0;
  char *fmtv = uformat(tank.gallons()-fueladd);
  tft.setTextDatum(TL_DATUM);

  tft.drawString("Did you just fill ", 10, 30, 4);
  tft.drawString(format(tank.gallons()-fueladd),110,60,6);
  if(parms[currentTripResetTimeoutUSIdx]==2){ // L/100km units

    tft.drawString("litres...", 230, 100, 4);
  }
  else{
    tft.drawString("gallons...", 230, 100, 4);
  }

  tft.setTextPadding(16);


  while(true){
    tft.setTextColor(TFT_WHITE, TFT_BLACK);

    tft.drawString("YES", 30, 160, 4);
    tft.drawString("NO", 250, 160, 4);
    tft.drawString("CANCEL", 114, 190, 4);

    myTouch.read();
    xss = myTouch.getX();
    yss = myTouch.getY();
    if (touchorient==0){ 
      xss=320-xss;
      yss=240-yss;
    }

    if (yss>=150){   
      if (xss>=0 && xss<=80){
        cp=cp+1;
        tft.setTextColor(TFT_BLACK,TFT_WHITE);
        tft.drawString("YES", 30, 160, 4);
        tft.setTextColor(TFT_WHITE, TFT_BLACK);

        if (cp>=2) {
          /////////////////
          tft.fillScreen(TFT_BLACK); 
          tank.reset(); 
          tft.fillScreen(TFT_BLACK);

          tft.setTextColor(TFT_WHITE, TFT_BLACK);

          tft.drawString("TANK RESET",40,100,4);
          delay2(1000);

          return false;
        }
      };
      if (xss>=120 && xss<=200){
        tft.setTextColor(TFT_BLACK,TFT_WHITE);
        tft.drawString("CANCEL", 114, 190, 4);
        tft.setTextColor(TFT_WHITE, TFT_BLACK);
        cp=cp+1;
        if (cp>=2) { 
          tft.fillScreen(TFT_BLACK);  
          return false;
        }
      };
      if (xss>=240 && xss<=318){
        tft.setTextColor(TFT_BLACK,TFT_WHITE);
        tft.drawString("NO", 250, 160, 4);
        tft.setTextColor(TFT_WHITE, TFT_BLACK);
        cp=cp+1;
        if (cp>=2) { 
          tft.fillScreen(TFT_BLACK);  
          delay2(1000);
          configtank();
          return false;
        }
      };
    }
    if (xss==-1) cp=0;  
    if (xss==321) cp=0;  


    delay2(35);
  }


}



boolean editFill(unsigned char parmIdx){
  unsigned long v = parms[parmIdx];
  long xss,yss;
  unsigned char p=5;  //right end of 10 digit number
  unsigned char keyLock=1;    
  char *fmtv = "0000000000";
  tft.setTextDatum(TL_DATUM);

  /* -- line 1 -- */
  tft.drawString("Top up added to tank", 10, 30, 4);
  tft.drawString("OK   EXIT",166,70,4);
  tft.setTextPadding(16);
  if(parms[currentTripResetTimeoutUSIdx]==2){ // L/100km units
    tft.drawString("L",10+(14*(9)),70,4);
  }
  else{
    tft.drawString("G",10+(14*(9)),70,4);
  }  


  tft.fillRect(   20,188,40,8,TFT_WHITE);
  tft.fillRect(   121,167,8,50,TFT_WHITE);
  tft.fillRect(   191,167,8,50,TFT_WHITE);
  tft.fillRect(   260,188,40,8,TFT_WHITE);

  tft.drawLine( 125,149,115,168,TFT_WHITE);
  tft.drawLine( 125,149,116,168,TFT_WHITE);
  tft.drawLine( 125,149,117,168,TFT_WHITE);
  tft.drawLine( 125,149,118,168,TFT_WHITE);
  tft.drawLine( 125,149,119,168,TFT_WHITE);
  tft.drawLine( 125,149,120,168,TFT_WHITE);
  tft.drawLine( 125,149,121,168,TFT_WHITE);
  tft.drawLine( 125,149,122,168,TFT_WHITE);
  tft.drawLine( 125,149,123,168,TFT_WHITE);
  tft.drawLine( 125,149,124,168,TFT_WHITE);
  tft.drawLine( 125,149,125,168,TFT_WHITE);
  tft.drawLine( 125,149,126,168,TFT_WHITE);
  tft.drawLine( 125,149,127,168,TFT_WHITE);
  tft.drawLine( 125,149,128,168,TFT_WHITE);
  tft.drawLine( 125,149,129,168,TFT_WHITE);
  tft.drawLine( 125,149,130,168,TFT_WHITE);
  tft.drawLine( 125,149,131,168,TFT_WHITE);
  tft.drawLine( 125,149,132,168,TFT_WHITE);
  tft.drawLine( 125,149,133,168,TFT_WHITE);
  tft.drawLine( 125,149,134,168,TFT_WHITE);
  // tft.drawLine( 125,150,135,170,TFT_WHITE);


  tft.drawLine( 195,235,185,216,TFT_WHITE);
  tft.drawLine( 195,235,186,216,TFT_WHITE);
  tft.drawLine( 195,235,187,216,TFT_WHITE);
  tft.drawLine( 195,235,188,216,TFT_WHITE);
  tft.drawLine( 195,235,189,216,TFT_WHITE);
  tft.drawLine( 195,235,190,216,TFT_WHITE);
  tft.drawLine( 195,235,191,216,TFT_WHITE);
  tft.drawLine( 195,235,192,216,TFT_WHITE);
  tft.drawLine( 195,235,193,216,TFT_WHITE);
  tft.drawLine( 195,235,194,216,TFT_WHITE);
  tft.drawLine( 195,235,195,216,TFT_WHITE);
  tft.drawLine( 195,235,196,216,TFT_WHITE);
  tft.drawLine( 195,235,197,216,TFT_WHITE);
  tft.drawLine( 195,235,198,216,TFT_WHITE);
  tft.drawLine( 195,235,199,216,TFT_WHITE);
  tft.drawLine( 195,235,200,216,TFT_WHITE);
  tft.drawLine( 195,235,201,216,TFT_WHITE);
  tft.drawLine( 195,235,202,216,TFT_WHITE);
  tft.drawLine( 195,235,203,216,TFT_WHITE);
  tft.drawLine( 195,235,204,216,TFT_WHITE);

  tft.drawLine( 5,192,25,182,TFT_WHITE);
  tft.drawLine( 5,192,25,183,TFT_WHITE);
  tft.drawLine( 5,192,25,184,TFT_WHITE);
  tft.drawLine( 5,192,25,185,TFT_WHITE);
  tft.drawLine( 5,192,25,186,TFT_WHITE);
  tft.drawLine( 5,192,25,187,TFT_WHITE);
  tft.drawLine( 5,192,25,188,TFT_WHITE);
  tft.drawLine( 5,192,25,189,TFT_WHITE);
  tft.drawLine( 5,192,25,190,TFT_WHITE);
  tft.drawLine( 5,192,25,191,TFT_WHITE);
  tft.drawLine( 5,192,25,192,TFT_WHITE);
  tft.drawLine( 5,192,25,193,TFT_WHITE);
  tft.drawLine( 5,192,25,194,TFT_WHITE);
  tft.drawLine( 5,192,25,195,TFT_WHITE);
  tft.drawLine( 5,192,25,196,TFT_WHITE);
  tft.drawLine( 5,192,25,197,TFT_WHITE);
  tft.drawLine( 5,192,25,198,TFT_WHITE);
  tft.drawLine( 5,192,25,199,TFT_WHITE);
  tft.drawLine( 5,192,25,200,TFT_WHITE);
  tft.drawLine( 5,192,25,201,TFT_WHITE);
  tft.drawLine( 5,192,25,202,TFT_WHITE);
  tft.drawLine( 5,192,25,203,TFT_WHITE);
  // tft.drawLine( 5,192,25,204,TFT_WHITE);



  tft.drawLine(295,182,315,192,TFT_WHITE);
  tft.drawLine(295,183,315,192,TFT_WHITE);
  tft.drawLine(295,184,315,192,TFT_WHITE);
  tft.drawLine(295,185,315,192,TFT_WHITE);
  tft.drawLine(295,186,315,192,TFT_WHITE);
  tft.drawLine(295,187,315,192,TFT_WHITE);
  tft.drawLine(295,188,315,192,TFT_WHITE);
  tft.drawLine(295,189,315,192,TFT_WHITE);
  tft.drawLine(295,190,315,192,TFT_WHITE);
  tft.drawLine(295,191,315,192,TFT_WHITE);
  tft.drawLine(295,192,315,192,TFT_WHITE);
  tft.drawLine(295,193,315,192,TFT_WHITE);
  tft.drawLine(295,194,315,192,TFT_WHITE);
  tft.drawLine(295,195,315,192,TFT_WHITE);
  tft.drawLine(295,196,315,192,TFT_WHITE);
  tft.drawLine(295,197,315,192,TFT_WHITE);
  tft.drawLine(295,198,315,192,TFT_WHITE);
  tft.drawLine(295,199,315,192,TFT_WHITE);
  tft.drawLine(295,200,315,192,TFT_WHITE);
  tft.drawLine(295,201,315,192,TFT_WHITE);
  tft.drawLine(295,202,315,192,TFT_WHITE);
  tft.drawLine(295,203,315,192,TFT_WHITE);
  /* -- line 2 -- */
  tft.drawString(fmtv,10,70,4);

  /* -- turn the cursor on -- */
  //   LCD::LcdCommandWrite(LCD_DisplayOnOffCtrl | LCD_DisplayOnOffCtrl_DispOn | LCD_DisplayOnOffCtrl_CursOn);
  /* cursor on 'OK' by default except for contrast */
  // (parmIdx == contrastIdx) ? p=8 : p=10;  

  while(true){

    tft.fillRect(9+(14*(7)),88,3,3,TFT_WHITE); 
    //  tft.fillRect(9+(14*(9)),70,15,21,TFT_BLACK); 
    tft.drawString("L",11+(14*(9)),70,4);

    tft.drawLine(9,91,330,91,TFT_BLACK);
    tft.drawLine(9,92,330,92,TFT_BLACK);
    if (p==10){
      tft.drawLine(165,91,205,91,TFT_WHITE);  //blue 
      tft.drawLine(165,92,205,92,TFT_WHITE);  //blue 
    }
    else
      if (p==11){
        tft.drawLine(216,91,270,91,TFT_WHITE);  //blue 
        tft.drawLine(216,92,270,92,TFT_WHITE);  //blue 
      }
    else{
      tft.drawLine(9+(14*(p)),91,9+(14*(p))+15,91,TFT_WHITE);  //blue 
      tft.drawLine(9+(14*(p)),92,9+(14*(p))+15,92,TFT_WHITE);  //blue 
    }


    tft.setCursor(0, 0);

    myTouch.read();
    xss = myTouch.getX();
    yss = myTouch.getY();
    if (touchorient==0){ 
      xss=320-xss;
      yss=240-yss;
    }
    //press ok
    if (yss>=60 && yss<=125){
      if (parmIdx!=0 && parmIdx!=4 && parmIdx!=8) {
        if (xss>=10 && xss<=23) p=0;
        if (xss>=23 && xss<=36) p=1;
        if (xss>=38 && xss<=51) p=2;
        if (xss>=52 && xss<=63) p=3;
        if (xss>=66 && xss<=79) p=4;
        if (xss>=80 && xss<=93) p=5;
        if (xss>=94 && xss<=107) p=6;
        if (xss>=108 && xss<=121) p=7;
        if (xss>=122 && xss<=135) { 
          p=8;
          cp=0;
        }
      } 
      // if (xss>=136 && xss<=149) p=9;

      if (xss>=162 && xss<=205){
        p=10;
        cp=cp+1;
        if (cp>=6) {
          cp=0;
          fueladd=fueladd+rformat(fmtv);
          SCREEN=tempscreen;
          tft.fillScreen(TFT_BLACK);

          delay2(250);
          return true;
        }
      }
      if (xss>=211 && xss<=275){
        p=11;
        cp=cp+1;
        if (cp>=6) {
          cp=0;
          tft.fillScreen(TFT_BLACK);
          SCREEN=tempscreen;
          delay2(250);
          return false;
        }
      }
    }


    //arrows
    if (yss>=150){   
      if (xss>=0 && xss<=70){
        cp=cp+1;
        if (cp>=2) {
          p--;
          if(p==255)p=11;
          if(p==9)p=8;
          cp=0;
        }
      };
      if (xss>=85 && xss<=155){
        cp=cp+1;
        if (cp>=2) { 
          {
            ;
            cp=0;
            if(p==10){  //ok selected
              //parms[parmIdx]=rformat(fmtv);
              //   LCD::LcdCommandWrite(B00001100); //cursor off
              tft.fillScreen(TFT_BLACK);
              fueladd=fueladd+rformat(fmtv);
              SCREEN=tempscreen;
              delay2(250);
              return true;
            }
            else if(p==11){  //cancel selected
              //    LCD::LcdCommandWrite(B00001100); //cursor off
              tft.fillScreen(TFT_BLACK);
              SCREEN=tempscreen;
              delay2(250);
              return false;
            }   			 

            unsigned char n = fmtv[p]-'0';
            n++;
            if (n > 9) n=0;
            if(p==0 && n > 3) n=0;
            fmtv[p]='0'+ n;
            //   LCD::gotoXY(0,1);        
            //    LCD::print(fmtv);
            //   LCD::gotoXY(p,1);  
            tft.drawString(fmtv,10,70,4);
          }  
        }
      };
      if (xss>=165 && xss<=236 && p<=9){
        cp=cp+1;
        if (cp>=2){
          cp=0;
          unsigned char n = fmtv[p]-'0';
          n--;
          if (n ==255 ) n=9;
          if(p==0 && n > 3) n=0;
          fmtv[p]='0'+ n;
          //   LCD::gotoXY(0,1);        
          //    LCD::print(fmtv);
          //   LCD::gotoXY(p,1);  
          tft.drawString(fmtv,10,70,4);
        }
      }
      if (xss>=250 && xss<=318){
        cp=cp+1;
        if (cp>=2) {
          p++;
          if(p==12)p=0;
          if(p==9)p=10;
          cp=0;
        }
      };
    }
    if (xss==-1) cp=0;  
    if (xss==321) cp=0;  







    delay2(35);
  }


}



void filltank(){ //edit all the parameters
  for(int x = 0; x<1; x++) {
    if (!editFill(x)) break;
  }
  HOLD_DISPLAY=1;
}  

void configtank(){ //edit all the parameters
  for(int x = 0; x<1; x++) {
    if (!configFill(x)) break;
  }
  tank.reset();
  tft.fillScreen(TFT_BLACK);


  tft.setTextColor(TFT_WHITE, TFT_BLACK);

  tft.drawString("TANK RESET",40,100,4);
  tft.drawString("Accuracy Adjusted",40,130,4);
  save();

  HOLD_DISPLAY=1;
}  

void configtankcheck(){ //edit all the parameters
  for(int x = 0; x<1; x++) {
    if (!configFillcheck(x)) break;
  }
  HOLD_DISPLAY=1;
}  


void initGuino(){ //edit all the parameters



  for(int x = 0; x<mylength(parms); x++) {
    if (!editParm(x)) break;
  }
  save();
  HOLD_DISPLAY=1;
}  

unsigned long millis2(){
  return timer2_overflow_count * 64UL * 2 / (16000000UL / 128000UL);
}

void delay2(unsigned long ms){
  unsigned long start = millis2();
  while (millis2() - start < ms);
}

/* Delay for the given number of microseconds.  Assumes a 16 MHz clock. 
 * Disables interrupts, which will disrupt the millis2() function if used
 * too frequently. */
void delayMicroseconds2(unsigned int us){
  uint8_t oldSREG;
  if (--us == 0)	return;
  us <<= 2;
  us -= 2;
  oldSREG = SREG;
  cli();
  // busy wait
  __asm__ __volatile__ (
  "1: sbiw %0,1" "\n\t" // 2 cycles
"brne 1b" : 
  "=w" (us) : 
  "0" (us) // 2 cycles
    );
  // reenable interrupts.
  SREG = oldSREG;
}

void init2(){
  // this needs to be called before setup() or some functions won't
  // work there
  sei();

  // timer 0 is used for millis2() and delay2()
  timer2_overflow_count = 0;
  // on the ATmega168, timer 0 is also used for fast hardware pwm
  // (using phase-correct PWM would mean that timer 0 overflowed half as often
  // resulting in different millis2() behavior on the ATmega8 and ATmega168)
  TCCR2A=1<<WGM20|1<<WGM21;
  // set timer 2 prescale factor to 64
  TCCR2B=1<<CS22;


  //      TCCR2A=TCCR0A;
  //      TCCR2B=TCCR0B;
  // enable timer 2 overflow interrupt
  TIMSK2|=1<<TOIE2;
  // disable timer 0 overflow interrupt
  TIMSK0&=!(1<<TOIE0);
}




/* ------------------------------------------------------------------ */
#if( SLEEP_CFG == 3 )
void system_sleep() {
  set_sleep_mode(SLEEP_MODE_PWR_DOWN); // sleep mode is set here
  sleep_enable();
  sleep_mode();                        // System sleeps here
  sleep_disable();                     // System continues execution here when watchdog timed out 
}
#endif
/* ------------------------------------------------------------------ */






unsigned long batteryVoltage(void){
  float vout = 0.0;
  float vin = 0.0;
  float R1 = 51000.0;    // !! resistance of R1 !! 47000
  float R2 = 10000.0;     // !! resistance of R2 !! 9500
  int value = 0;

  value = analogRead(temp2Pin);
  vout = (value * 5.0) / 1024.0;
  vin = vout / (R2/(R1+R2));

  // actual voltage is 0.7V higher - we are measuring after 1N4004 diode voltage drop
  //return vin * 1000 - 300 + parms[voltmeterOffsetIdx];

  vin = vin * 1000 - 1000 + parms[voltmeterOffsetIdx];   
  return ((unsigned long)vin / 100)*100; //make last digit to be 0
} 







void convert(){
  float mile=1.6093;
  float gallonz=3.785411784;
  float math;
  float answer;
  if (parms[currentTripResetTimeoutUSIdx]==1) {
    //metric to imperial
    math = parms[vssPulsesPerMileIdx] ;
    answer=math * mile;
    parms[vssPulsesPerMileIdx] = answer;

    math = parms[microSecondsPerGallonIdx] ;
    answer=math * gallonz;
    parms[microSecondsPerGallonIdx] = answer; 

    math = parms[tankSizeIdx] ;
    answer=math / gallonz;
    parms[tankSizeIdx] = answer; 
  }
  if (parms[currentTripResetTimeoutUSIdx]==2) {
    //imperial to metric
    math = parms[vssPulsesPerMileIdx] ;
    answer=math / mile;
    parms[vssPulsesPerMileIdx] = answer;

    math = parms[microSecondsPerGallonIdx] ;
    answer=math / gallonz;
    parms[microSecondsPerGallonIdx] = answer; 

    math = parms[tankSizeIdx] ;
    answer=math * gallonz;
    parms[tankSizeIdx] = answer; 
  }
  oldset=parms[currentTripResetTimeoutUSIdx];

}








void bluetooth()
{

  while (Serial1.available())
  {
    readflag=Serial1.read();
    Serial.print(readflag);
    if (readflag=='M'){
      delay2(2);

      readflag=Serial1.read();

      if (readflag=='M'){
        brek=0;
        senddd=2;
      }
      else
        if (readflag=='T'){
          tank.reset();
          fueladd=0;
          saveTankData();
        }
        else
          if (readflag=='R'){
            current.reset(); 
            saveTankData();

          }

    }
    else
      if (readflag=='!'){
        loopnz=0;
        bluetoothtrigger=1;
        senddd=1;
        brek=1;
        delay(100);
        break;
        delay2(20);
      }
      else
        if (readflag=='R'){
          loopnz=0;

          az = Serial1.readStringUntil('K');
          cz = Serial1.readStringUntil('K');
          if (az==cz) parms[vssPulsesPerMileIdx]=(long)az.toInt();
          save();
          delay2(20);
        }
        else
          if (readflag=='S'){
            loopnz=0;

            az = Serial1.readStringUntil('K');
            cz = Serial1.readStringUntil('K');
            if (az==cz) parms[microSecondsPerGallonIdx]=az.toInt();
            save();
            delay2(20);
          }
          else
            if (readflag=='T'){
              loopnz=0;

              az = Serial1.readStringUntil('K');
              cz = Serial1.readStringUntil('K');
              if (az==cz) parms[injPulsesPer2Revolutions]=az.toInt();
              save();
              delay2(20);
            }
            else
              if (readflag=='U'){
                loopnz=0;

                az = Serial1.readStringUntil('K');
                cz = Serial1.readStringUntil('K');
                oldset=parms[currentTripResetTimeoutUSIdx];
                if (az==cz) parms[currentTripResetTimeoutUSIdx]=az.toInt();
                save();
                delay2(20);
              }
              else
                if (readflag=='V'){
                  loopnz=0;

                  az = Serial1.readStringUntil('K');
                  cz = Serial1.readStringUntil('K');
                  if (az==cz) parms[tankSizeIdx]=az.toInt();
                  save();
                  delay2(20);
                }
                else
                  if (readflag=='W'){
                    loopnz=0;

                    az = Serial1.readStringUntil('K');
                    cz = Serial1.readStringUntil('K');
                    if (az==cz) parms[injectorSettleTimeIdx]=az.toInt();
                    save();
                    delay2(20);
                  }
                  else
                    if (readflag=='X'){
                      loopnz=0;

                      az = Serial1.readStringUntil('K');
                      cz = Serial1.readStringUntil('K');
                      if (az==cz) parms[vsspause]=az.toInt();
                      save();
                      delay2(20);
                    }
                    else
                      if (readflag=='Y'){
                        loopnz=0;

                        az = Serial1.readStringUntil('K');
                        cz = Serial1.readStringUntil('K');
                        if (az==cz) parms[injEdgeIdx]=az.toInt();
                        save();
                        delay2(20);
                      }
                      else
                        if (readflag=='Z'){
                          loopnz=0;

                          az = Serial1.readStringUntil('K');
                          cz = Serial1.readStringUntil('K');
                          if (az==cz) parms[voltmeterOffsetIdx]=az.toInt();
                          save();
                          delay2(20);
                        }
                        else
                          if (readflag=='@'){
                            loopnz=0;

                            az = Serial1.readStringUntil('K');
                            cz = Serial1.readStringUntil('K');
                            if (az==cz) fueladd=fueladd+az.toInt();

                            saveTankData();

                            delay2(20);
                          }
                        else{
                          if (brek==0){
                            //     senddd=1;

                            // Serial.write("ER");
                          }

                        }

  }

  //senddd=0;
  if (senddd==1) {
    loopnz=loopnz+1;
    if (loopnz>=2 && loopnz<=8){
      Serial1.print("U"+String(parms[currentTripResetTimeoutUSIdx]));
      delay2(20);
      Serial1.print("A"+String(instantmph()/10));
      delay2(20); 
      Serial1.print("B"+String(batteryVoltage()));
      delay2(20); 
      Serial1.print("C"+String(tank.gallons()/10));
      delay2(20); 
      Serial1.print("D"+String(current.miles()/10));
      delay2(20); 
      Serial1.print("E"+String(tank.miles()/10));
      delay2(20); 
      Serial1.print("F"+String(getDTE()/10));
      delay2(20);
      Serial1.print("G"+String(instantrpm()/1000));
      delay2(20);
      if(instantmph()==0) 
        Serial1.print("H"+String(instantgph()/10));
      else 
        Serial1.print("H"+String(instantmpg()/10));
      delay2(20);
      Serial1.print("I"+String(current.mpg()/10));
      delay2(20);
      Serial1.print("J"+String(tank.mpg()/10));
      delay2(20);
      Serial1.print("L"+String(current.gallons()/10));
      delay2(20);

    }
  }
  if (loopnz==8) {
    //senddd=2;
    loopnz=0;
  }

  if (senddd==2){

    delay2(20);
    Serial1.print("R"+String(parms[vssPulsesPerMileIdx]));
    delay2(20); 
    Serial1.print("S"+String(parms[microSecondsPerGallonIdx]));
    delay2(20); 
    Serial1.print("T"+String(parms[injPulsesPer2Revolutions]));
    delay2(20); 
    Serial1.print("U"+String(parms[currentTripResetTimeoutUSIdx]));
    delay2(20);
    Serial1.print("V"+String(parms[tankSizeIdx]));
    delay2(20);
    Serial1.print("W"+String(parms[injectorSettleTimeIdx]));
    delay2(20);
    Serial1.print("X"+String(parms[vsspause]));
    delay2(20);
    Serial1.print("Y"+String(parms[injEdgeIdx]));
    delay2(20);
    Serial1.print("Z"+String(parms[voltmeterOffsetIdx]));
    delay2(20);
    senddd=3;

  }
















}























